/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//
//	FileName	spi_eeprom.c
//	Version		1.00
//	MCU		R8C/2A_2B
//	Work		
//-------------------------------------------------------------------------------------------------
//
//	2008/05/30	Ver1.00
//-------------------------------------------------------------------------------------------------
//ldln
//	dipSW̒lSPIΉEEPROMɏ݁AǍ݂sʂLCDɕ\܂B
//	f[^EEPROMɏ݌Ad𗎂ƂĂf[^Ǎ߂܂B
//	xAf[^EEPROMǍނƃf[^폜܂B
//	SW2: SW3:Ǎ
//-------------------------------------------------------------------------------------------------
///////////////////////////////////////////////////////////////////////////////////////////////////
/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

@Copyright (C) Hokuto denshi Co,Ltd. 2008

*/
///////////////////////////////////////////////////////////////////////////////////////////////////
/* CN[ht@C錾 */

#include "R8C_2A_2B.h"

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ^錾 */
#define size 64
#define CS_BIT		0x01
#define SK_BIT		0x08
#define DI_BIT		0x04
#define DI_BITNO	2
#define DO_BIT		0x02
#define DO_BITNO	1
#define ST_SZ		1
#define OP_SZ		2

/* 93c46 16bit */
//#define EWEN_ADR	0x30
//#define EWDS_ADR	0x00
//#define ERAL_ADR	0x20
//#define ADR_SZ	6
//#define DAT_SZ	6

/* 93c46 8bit */
#define EWEN_ADR	0x60
#define EWDS_ADR	0x00
#define ERAL_ADR	0x40
#define ADR_SZ		7
#define DAT_SZ		8
///////////////////////////////////////////////////////////////////////////////////////////////////
/* ϐ錾 */

unsigned int x, y;

///////////////////////////////////////////////////////////////////////////////////////////////////
/* }N錾 */

#define ROM_PORT	P0

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ֐̃vg^Cv錾 */

void init_IO ( void );
void set_CLK ( void );
void wait ( unsigned long msec );
void main ( void );
unsigned int dip_select ( void );
void Clear_LCD ( void );
void Wait_LCD ( const unsigned long Interval );
void Print_LCD ( const char *String );
void Init_LCD ( void );
void Write_LCD ( const unsigned char RS_Mode ,const unsigned char Data );
void Locate_LCD ( const unsigned char X, const unsigned char Y );
unsigned int char_select (unsigned int c );

void Init_EEPROM ( void );
void ewen_rom ( void );
void ewds_rom ( void );
void read_rom ( unsigned char adr, unsigned short *dat );
void write_rom ( unsigned char adr, unsigned short dat );
void eral_rom ( void );

///////////////////////////////////////////////////////////////////////////////////////////////////
/* EEPROMڑ|[g */

void Init_EEPROM ( void )
{
	PRCR = 0x0f;
	PD0 = 0x0d;
	P0 = ( (P0 & ~0xff) | 0x0d );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* I/OCvbg */

void init_IO ( void )
{
	PRCR = 0x0f;		// veNgWX^
	PD1 = 0x03;		// P1_0P1_1LEDo
	PD3 = 0x00;		// SW2,SW3gp
	PD5 = 0xff;		// LCD_04~07
	PD6 = 0x03;		// LCD_E,LCD_RS
	
	PUR0 = 0xC1;		// vAbvWX^
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* NbNZbg */

void set_CLK ( void )
{
/* ONbN20MHz */
	CM1 = 0x08;
	CM0 = 0x14; 
	OCD = 0x00; 
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* dip_SW */

unsigned int dip_select ( void )
{	
	unsigned int dip;
	unsigned int cun;
	
	dip = 0xff & P0;
	dip = dip >> 4;
	cun = 0;
	
	if((0x01 == (dip & 0x01))){
		cun = cun + 1;
	}
	if((0x02 == (dip & 0x02))){
		cun = cun + 1;
	}
	if((0x04 == (dip & 0x04))){
		cun = cun + 1;	
	}
	if((0x08 == (dip & 0x08))){
		cun = cun + 1;
	}
	return cun;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* EFCg */
void wait ( unsigned long msec )
{
	unsigned long i;

	for(i=0; i<1000*msec; i++);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ERASE/WRITE */

void ewen_rom ( void )
{
	int i;
	unsigned char buf[10];
	
	for(i=0; i<1; i++){
		buf[i] = 1;
	}
	for(i=0; i<2; i++){
		buf[(i+1)] = ((0 >> (2 - 1 - i )) & 0x01);
	}
	for(i=0; i<7; i++){
		buf[(i+1+2)] = ((0x60 >> (7 - 1 - i )) & 0x01);
	}
	for(i=0; i<(1 + 2 +7); i++){
		buf[i] = (buf[i] << DI_BITNO);
	}
	ROM_PORT = ROM_PORT | CS_BIT;			//CS:H
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ); i++){
		ROM_PORT = ROM_PORT | buf[i];		//DI:H
		ROM_PORT = ROM_PORT | SK_BIT;		//SK:H
		ROM_PORT = ROM_PORT & ~DI_BIT;		//DI:L
		ROM_PORT = ROM_PORT & ~SK_BIT;		//SK:L
	}
	ROM_PORT = ROM_PORT & ~CS_BIT;			//CS:L
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* WRITE/WRITE_DISABLE */

void ewds_rom ( void )
{
	int i;
	unsigned char buf[(ST_SZ + OP_SZ + ADR_SZ)];
	
	for(i=0; i<ST_SZ; i++){
		buf[i] = 1;
	}
	for(i=0; i<OP_SZ; i++){
		buf[(i+ST_SZ)] = ((0 >> (OP_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<ADR_SZ; i++){
		buf[(i+ST_SZ+OP_SZ)] = ((EWDS_ADR >> (ADR_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ); i++){
		buf[i] = (buf[i] << DI_BITNO);
	}
	ROM_PORT = ROM_PORT | CS_BIT;			//CS:H
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ); i++){
		ROM_PORT = ROM_PORT | buf[i];		//DI:H
		ROM_PORT = ROM_PORT | SK_BIT;		//SK:H
		ROM_PORT = ROM_PORT & ~DI_BIT;		//DI:L
		ROM_PORT = ROM_PORT & ~SK_BIT;		//SK:L
	}
	ROM_PORT = ROM_PORT & ~CS_BIT;			//CS:L
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* READ */

void read_rom ( unsigned char adr, unsigned short *dat )
{
	int i;
	unsigned char buf[(ST_SZ + OP_SZ + ADR_SZ)];
	
	for(i=0; i<ST_SZ; i++){
		buf[i] = 1;
	}
	for(i=0; i<OP_SZ; i++){
		buf[(i+ST_SZ)] = ((2 >> (OP_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<ADR_SZ; i++){
		buf[(i+ST_SZ+OP_SZ)] = ((adr >> (ADR_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ); i++){
		buf[i] = (buf[i] << DI_BITNO);
	}
	ROM_PORT = ROM_PORT | CS_BIT;			//CS:H
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ); i++){
		ROM_PORT = ROM_PORT | buf[i];		//DI:H
		ROM_PORT = ROM_PORT | SK_BIT;		//SK:H
		ROM_PORT = ROM_PORT & ~DI_BIT;		//DI:L
		ROM_PORT = ROM_PORT & ~SK_BIT;		//SK:L
	}
	for(i=0; i<DAT_SZ; i++){
		ROM_PORT = ROM_PORT | SK_BIT;		//SK:H
		buf[i] = ROM_PORT; 
		ROM_PORT = ROM_PORT & ~SK_BIT;		//SK:L
	}
	*dat = 0;
	for(i=0; i<DAT_SZ; i++){
		*dat = (*dat << 1) | ((buf[i] & DO_BIT) >> DO_BITNO);
	}
	ROM_PORT = ROM_PORT & ~CS_BIT;			//CS:L
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* WRITE */

void write_rom ( unsigned char adr, unsigned short dat )
{
	int i;
	unsigned char buf[(ST_SZ + OP_SZ + ADR_SZ + DAT_SZ)];
	
	for(i=0; i<ST_SZ; i++){
		buf[i] = 1;
	}
	for(i=0; i<OP_SZ; i++){
		buf[(i+ST_SZ)] = ((1 >> (OP_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<ADR_SZ; i++){
		buf[(i+ST_SZ+OP_SZ)] = ((adr >> (ADR_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<DAT_SZ; i++){
		buf[(i+ST_SZ+OP_SZ+ADR_SZ)] = ((dat >> (DAT_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ + DAT_SZ); i++){
		buf[i] = (buf[i] << DI_BITNO);
	}
	ROM_PORT = ROM_PORT | CS_BIT;			//CS:H
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ + DAT_SZ); i++){
		ROM_PORT = ROM_PORT | buf[i];		//DI:H
		ROM_PORT = ROM_PORT | SK_BIT;		//SK:H
		ROM_PORT = ROM_PORT & ~DI_BIT;		//DI:L
		ROM_PORT = ROM_PORT & ~SK_BIT;		//SK:L
	}
	ROM_PORT = ROM_PORT & ~CS_BIT;			//CS:L
	ROM_PORT = ROM_PORT | CS_BIT;			//CS:H
	while((ROM_PORT & DO_BIT)==0){
		ROM_PORT = ROM_PORT | SK_BIT;		//SK:H
		ROM_PORT = ROM_PORT & ~SK_BIT;		//SK:L
	}
	ROM_PORT = ROM_PORT & ~CS_BIT;			//CS:L
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ERASE_ALL */

void eral_rom ( void )
{
	int i;
	unsigned char buf[(ST_SZ + OP_SZ + ADR_SZ)];
	
	for(i=0; i<ST_SZ; i++){
		buf[i] = 1;
	}
	for(i=0; i<OP_SZ; i++){
		buf[(i+ST_SZ)] = ((0 >> (OP_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<ADR_SZ; i++){
		buf[(i+ST_SZ+OP_SZ)] = ((ERAL_ADR >> (ADR_SZ - 1 - i )) & 0x01);
	}
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ); i++){
		buf[i] = (buf[i] << DI_BITNO);
	}
	ROM_PORT = ROM_PORT | CS_BIT;			//CS:H
	for(i=0; i<(ST_SZ + OP_SZ + ADR_SZ); i++){
		ROM_PORT = ROM_PORT | buf[i];		//DI:H
		ROM_PORT = ROM_PORT | SK_BIT;		//SK:H
		ROM_PORT = ROM_PORT & ~DI_BIT;		//DI:L
		ROM_PORT = ROM_PORT & ~SK_BIT;		//SK:L
	}
	ROM_PORT = ROM_PORT & ~CS_BIT;			//CS:L
	ROM_PORT = ROM_PORT | CS_BIT;			//CS:H
	while((ROM_PORT & DO_BIT)==0){
		ROM_PORT = ROM_PORT | SK_BIT;		//SK:H
		ROM_PORT = ROM_PORT & ~SK_BIT;		//SK:L
	}
	ROM_PORT = ROM_PORT & ~CS_BIT;			//CS:L
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD */
void Init_LCD ( void )
{
	P5 = 0x00;
	P6 = 0x00;
	
	Wait_LCD ( 20 );
	
	P6 = P6 & ~0x02;		// RS Low Set
	
	/* LCD1 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x03;	// MM1
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
	Wait_LCD ( 5 );
	
	/* LCD2 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x03;	// MM2
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
	
	/* LCD3 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x03;	// MM3
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
	
	/* LCD4 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x02;	// MM4
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
	
	/* t@NVZbgFSrbgoXAQsAT~Vhbg */
	Write_LCD ( 0 , 0x28 );
	
	/* Gg[[hFJ[\CNgAJ[\ړ */
	Write_LCD ( 0 , 0x06 );

	/* J[\/\VtgFJ[\EVtg */
	Write_LCD ( 0 , 0x10 );

	/* \ON/OFFRg[FfBXvC\AJ[\\AuN\ */
	Write_LCD ( 0 , 0x0d );

	/* \NA */
	Clear_LCD ();
	
	Wait_LCD ( 5 );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD\ */

void Write_LCD (
	const unsigned char RS_Mode ,
	const unsigned char Data
)
{
	/* 4rbg̏ꍇ */
	/* RS Setting */
	if ( RS_Mode == 0 )
	{
		P6 = P6 & ~0x02;	// RS Low Set
	}
	else if ( RS_Mode == 1 )
	{
		P6 = P6 | 0x02;		// RS High Set
	}
	
	/* 4rbg */
	P6 = P6 | 0x01;			// E High Set
	
	P5 = ( P5 & 0xf0 ) | (( Data >> 4 ) & 0x0f );	// 4rbg
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
	
	/* 4rbg */
	P6 = P6 | 0x01;			// E High Set

	P5 = ( P5 & 0xf0 ) | (  Data & 0x0f );		// 4rbg
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
}
	
///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD J[\ړ */
	
void Locate_LCD ( const unsigned char X, const unsigned char Y )
{
	unsigned char i;
	i = Y * 0x40 + X;
	i = i | 0x80;
	
	Write_LCD ( 0 , i );
	Wait_LCD ( 1 );
	
	/* J[\ۑ */
	x = X;
	y = Y;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD NA\ */
	
void Clear_LCD ( void )
{
	P6 = P6 & ~0x02;	// RS Low Set
	Write_LCD ( 0 , 0x01 );
	Wait_LCD ( 2 );
	Locate_LCD ( 0 , 0 );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* EFCgLCD */

void Wait_LCD ( const unsigned long Interval )
{
	volatile unsigned long i;
	for ( i = 0; i < Interval * 1000; ++i );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD\ */

void Print_LCD ( const char *String )
{
	unsigned char i, j;
	
	/* \[v */
	for ( i = 0; String[ i ] != '\0'; ++i )
	{
		/* ` */
		if (
			( String[ i ] >= 0x20 && String[ i ] <= 0x7f ) ||
			( String[ i ] >= 0xa1 && String[ i ] <= 0xfd )
		)
		{/* kbcR[h͈͓̔̏ꍇ */
			/* ` */
			Write_LCD ( 1, String[ i ] );
			Wait_LCD ( 1 );
			
		/* J[\ړ */
			if ( x ==  16 - 1 )
			{/* 16sI[o[ꍇ */
				x = 0;
				y = ( y == 0 ? 1 : 0 );
				Locate_LCD ( x, y );
			}
			else
			{/* 16sȓ̏ꍇ */
				++x;
				Locate_LCD ( x, y );
			}
		}
		else if ( String[ i ] == '\n' )
		{/* sR[h̏ꍇ */
			x = 0;
			y = ( y == 0 ? 1 : 0 );
			Locate_LCD ( x, y );
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ZNg */
unsigned int char_select ( unsigned int c )
{
	unsigned int out;
	switch (c)
	{
	case 0:
	out = 0x41;	// "A"
	break;
		
	case 1:
	out = 0x42;	// "B"
	break;
		
	case 2:
	out = 0x43;	// "C"
	break;
		
	case 3:
	out = 0x44;	// "D"
	break;
		
	case 4:
	out = 0x45;	// "E"
	break;
	}
	
	return out;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* C */

void main ()
{	
	unsigned char Title[] = "PSI AT93C46     Sample program";
	unsigned char input_m[] = "   Ͻ";
	unsigned char output_m[] = "   Ͻ";
	unsigned char output_no_m[] = "  Ͼ!";
	unsigned char output_e_m[] = "ް ޮ Ͻ";

	unsigned short Charactor;
	unsigned short lcdC;

	Init_EEPROM ();	// EEPROMڑ|[g
	init_IO ();	// I/O|[g
	set_CLK ();	// NbNZbg
	init_IO ();	// I/OCvbg
	Init_LCD ();	// LCD|[g
	
	Print_LCD ( Title );
	wait (500);
	Clear_LCD ();	// LCDNA\
	
	ewen_rom ();
	while(1)
	{
		/*  */
		if((P3 & 0x40) == 0)
		{
			write_rom ( 1, char_select (dip_select ()));
			P1 = 0x01;
			Locate_LCD ( 0, 1 );
			Write_LCD (1,char_select (dip_select ()));
			Print_LCD ( input_m );
			wait (300);
			Clear_LCD ();
		}
		
		Locate_LCD ( 0, 0 );
		
		/* Ǎ */
		if((P3 & 0x04) == 0)
		{
			read_rom ( 1, &Charactor);
			P1 = 0x02;
			lcdC = Charactor;
			if (( lcdC >= 0x20 && lcdC <= 0x7f ) ||	( lcdC >= 0xa1 && lcdC <= 0xfd ))
			{
				Write_LCD (1,lcdC);
				Print_LCD ( output_m );
				
				Locate_LCD ( 0, 1 );
				Print_LCD ( output_e_m );
				Locate_LCD ( 0, 0 );
				wait (400);

			}
			else if(lcdC == 0xff)
			{
				Print_LCD ( output_no_m );
				wait (300);
			}
			Clear_LCD ();
			eral_rom ();
			ewen_rom ();
			wait (50);
		}
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////
